#! /usr/bin/perl

#------------------------------------------------------------------------------
#	SK Editer Lite WEBサーバ上のテキスト編集システム
#	                        (C)SEKKAKU-NET 2007
#	                         2021-07-31 版
#------------------------------------------------------------------------------

# 編集リストの記録ファイル
$editlist = 'conf.cgi';


# パスワード制限を使う際のパスワード
# 使わない時は空
$loginpass = '';


# デザイン用スタイルシート
$css = <<_STYLEHTML_;
h1 {
	font-size: 18px;
}
h2 {
	font-size: 17px;
}
h3 {
	font-size: 16px;
}
h4 {
	font-size: 15px;
}
h5 {
	font-size: 14px;
}
h6 {
	font-size: 13px;
}
body,td,th {
	font-size: 14px;
	color: #000000;
}
body {
	background-color: #FFFFFF;
}
.titlecss {
	color: #FFFFFF;
	background-color: #000000;
	padding: 3px;
}
.subtitle {
	padding: 3px;
	border: 1px dotted #999999;
	margin-top: 30px;
}
li {
	margin-top: 5px;
}
.small {
	font-size: 10px;
}
_STYLEHTML_



#------------------------------------------------------------------------------
#------------------------------------------------------------------------------
# これ以降は実行分の為、perlに不慣れな方は触らない方が無難です。
# 改造後、一切の保証は受けられなくなりますのでご注意下さい。
#------------------------------------------------------------------------------

&decode;

if($loginpass){&login();}

if($FORM{'run'} eq "1"){ &openset; } 
if($FORM{'run'} eq "2" || $FORM{'run'} eq "3"){ &editlist; } 
if($FORM{'run'} eq "4"){ &makefile; } 
if($FORM{'run'} eq "5"){ &dellfile; } 
if($FORM{'run'} eq "6"){ &saveset; } 

&top;

#------------------------------------------------------------------------------
sub decode{

	use Encode qw/ from_to /;
	use Encode::Guess qw/ shiftjis 7bit-jis euc-jp /;
	
	if ($ENV{'REQUEST_METHOD'} eq "POST") {
		read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	} else { 
		 $buffer = $ENV{'QUERY_STRING'}; 
	}

	@pairs = split(/&/,$buffer);

	foreach $pair (@pairs) {
		($name, $value) = split(/=/, $pair);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$FORM{$name} = $value;
	}
	
	$scriptname = $ENV{SCRIPT_NAME};
	$scriptname =~ s|.*/([^/]+)$|$1|;

	if($FORM{'type'} eq "free"){
		$filepass = $FORM{'inputfile'};
	}else{
		$filepass = $FORM{'filelist'};
	}
	
	@editlist = &loadfile($editlist) if(-f $editlist);

}

#------------------------------------------------------------------------------
sub login{

	my ($errmes) = @_;
	if($FORM{'pass'} eq $loginpass){
		my $encpass = $FORM{'pass'};
		$encpass =~ s/([^ 0-9a-zA-Z])/"%".uc(unpack("H2",$1))/eg;
		$encpass =~ s/ /+/g;
		print 'Set-Cookie: skedit='.$encpass.';'."\n";
		return();
	}

	#Cookieの取得
	if($ENV{'HTTP_COOKIE'}){
		my @pairs=split(/;/,$ENV{'HTTP_COOKIE'});
		foreach $pair(@pairs){
			($name,$value)=split(/\=/,$pair);
			$name=~s/ //g;
			$value=~s/\+/ /g;
			$value=~s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
			$COOKIE{$name}=$value;
		}
		if($COOKIE{'skedit'} eq $loginpass){
			return();
		}
	}

	print "Content-type: text/html; charset=utf-8\n\n";
	
	print $ENV{'HTTP_COOKIE'}.'<!DOCTYPE html><html lang="ja">'."\n"; 
	print '<head>'."\n"; 
	print '<meta http-equiv="Content-Type" content="text/html; charset=utf-8">'."\n"; 
	print '<meta name="robots" content="noindex, nofollow">'."\n"; 
	print '<title>SK Editer Lite </title>'."\n"; 
	print '<style type="text/css">'."\n"; 
	print '<!--'."\n"; 
	print $css."\n"; 
	print '-->'."\n"; 
	print '</style>'."\n";
	
	print '<script language="JavaScript" type="text/JavaScript">'."\n" if($errmes);
	print '<!--'."\n" if($errmes);
	print ' alert("'.$errmes.'");'."\n" if($errmes);
	print '//-->'."\n" if($errmes);
	print '</script>'."\n" if($errmes);
	
	print '</head>'."\n"; 
	print ''."\n"; 
	print '<body>'."\n"; 
	print '<h1 class="titlecss">テキストファイルの編集ツール</h1>'."\n"; 
	print '<blockquote>'."\n"; 
	print '<div align="right">SK Editer Lite&nbsp;(<a href="'.$scriptname.'">Reset</a>&nbsp;<a href="#help">Help</a>)</div>'."\n"; 
	print '<h2 class="subtitle">ログイン</h2>'."\n"; 

	print '<form action="'.$scriptname.'" method="post">'."\n"; 
	print 'パスワード：'."\n"; 
	print '<input type="password" name="pass">'."\n";
	print '<input type="submit" value="ログイン">'."\n"; 
	print '</form>'."\n"; 

	print '</body>'."\n"; 
	print '</html>'."\n"; 

	exit;

}


#------------------------------------------------------------------------------
sub top{

	my ($errmes) = @_;


	print "Content-type: text/html; charset=utf-8\n\n";
	
	print '<!DOCTYPE html><html lang="ja">'."\n"; 
	print '<head>'."\n"; 
	print '<meta http-equiv="Content-Type" content="text/html; charset=utf-8">'."\n"; 
	print '<meta name="robots" content="noindex, nofollow">'."\n"; 
	print '<title>SK Editer Lite </title>'."\n"; 
	print '<style type="text/css">'."\n"; 
	print '<!--'."\n"; 
	print $css."\n"; 
	print '-->'."\n"; 
	print '</style>'."\n";
	
	print '<script language="JavaScript" type="text/JavaScript">'."\n" if($errmes);
	print '<!--'."\n" if($errmes);
	print ' alert("'.$errmes.'");'."\n" if($errmes);
	print '//-->'."\n" if($errmes);
	print '</script>'."\n" if($errmes);
	
	print '</head>'."\n"; 
	print ''."\n"; 
	print '<body>'."\n"; 
	print '<h1 class="titlecss">テキストファイルの編集ツール</h1>'."\n"; 
	print '<blockquote>'."\n"; 
	print '<div align="right">SK Editer Lite&nbsp;(<a href="'.$scriptname.'">Reset</a>&nbsp;<a href="#help">Help</a>)</div>'."\n"; 
	print '<h2 class="subtitle">読み込みフォーム</h2>'."\n"; 
	print '<form action="'.$scriptname.'" method="post" name="openpass" id="openpass">'."\n"; 
	print '<table border="0" cellpadding="0" cellspacing="10">'."\n"; 
	print '<tr>'."\n"; 
	print '<td scope="row"><input name="type" type="radio" value="free" checked id="1" onclick="this.form.inputfile.disabled=false; this.form.filelist.disabled=true;"> <label for="1">指定したファイル</label></td>'."\n"; 
	print '<td><input name="inputfile" type="text" id="inputfile" style="width:250px;">'."\n"; 
	print '<span class="small">（対象ファイルのパス）</span></td>'."\n"; 
	print '<td rowspan="2" valign="bottom">を</td>'."\n"; 
	print '<td rowspan="2" valign="bottom"><select name="run" id="run">'."\n"; 
	print '<option value="1" selected>編集フォームに開く</option>'."\n"; 
	print '<option value="2">登録リストに追加</option>'."\n"; 
	print '<option value="3">登録リストから削除</option>'."\n"; 
	print '<option value="4">ファイルを作成(新規)</option>'."\n"; 
	print '<option value="5">ファイルを削除</option>'."\n"; 
	print '</select></td>'."\n"; 
	
	print '<td rowspan="2" valign="bottom">'."\n"; 
	print '文字コード'."\n"; 
	print '<select name="code" id="code">'."\n"; 
	print '<option>UTF-8</option>'."\n"; 
	print '<option>shift-jis</option>'."\n"; 
	print '<option>euc</option>'."\n"; 
	print '<option>jis</option>'."\n"; 
	print '</select>'."\n"; 
	print '</td>'."\n"; 
	
	
	print '<td rowspan="2" valign="bottom"><input type="submit" name="Submit" value="　で開く　"></td>'."\n"; 
	print '</tr>'."\n"; 
	print '<tr>'."\n"; 
	print '<td scope="row"><input name="type" type="radio" value="edit" id="2" onclick="this.form.inputfile.disabled=true; this.form.filelist.disabled=false;"> <label for="2">登録したファイル</label></td>'."\n"; 
	print '<td><select name="filelist" id="filelist" style="width:250px;">'."\n"; 
	
	foreach $editlists (@editlist) {
		print '<option>'.$editlists.'</option>'."\n"; 
	}
	
	print '</select></td>'."\n"; 
	print '</tr>'."\n"; 
	print '</table>'."\n"; 
	print '</form>'."\n"; 
	
	print '<script language="JavaScript" type="text/JavaScript">'."\n";
	print '<!--'."\n";
	print '  openpass.filelist.disabled=true;;'."\n";
	print '//-->'."\n";
	print '</script>'."\n";
	
	print '<h2 class="subtitle">編集フォーム</h2>'."\n"; 
		
	if($FORM{'run'} ne "1"){ 
		$inputform = ' style="visibility:hidden;"';
	} 
	
	print '<form action="'.$scriptname.'" method="post" name="edit" id="edit" '.$inputform.'>'."\n"; 
	print '<h3><strong>読み込み中のファイル：'.$openfile.'</strong></h3>'."\n"; 
	print '<p>日本語文字コード'."\n"; 
	print '<select name="code" id="code">'."\n"; 
	print '<option'.$selectcd{"utf8"}.'>UTF-8</option>'."\n"; 
	print '<option'.$selectcd{"sjis"}.'>shift-jis</option>'."\n"; 
	print '<option'.$selectcd{"euc"}.'>euc</option>'."\n"; 
	print '<option'.$selectcd{"jis"}.'>jis</option>'."\n"; 
	print '</select>'."\n"; 
	print '改行コード'."\n"; 
	print '<select name="br" id="br">'."\n"; 
	print '<option value="LF"'.$selectbr{lf}.'>LF (\n)</option>'."\n"; 
	print '<option value="CR"'.$selectbr{cr}.'>CR (\r)</option>'."\n"; 
	print '<option value="CR+LF"'.$selectbr{crlf}.'>CR+LF (\r\n)</option>'."\n"; 
	print '</select><span class="small">（そのままでOK）</span>'."\n"; 
	print '<input type="submit" name="submit" value="更新する">'."\n"; 
	print '<input type="hidden" name="run" value="6">'."\n"; 
	print '<input type="hidden" name="file" value="'.$openfile.'"><br>'."\n"; 
	print '<textarea name="mes" id="mes" style="width:750px; height:450px; font-size:13px;">'.$editfiletxt.'</textarea>'."\n"; 
	print '</p>'."\n"; 
	print '</form>'."\n"; 
	print '<h2 class="subtitle"><a name="help">説明</a></h2>'."\n"; 
	print '<ul>'."\n"; 
	print '<li>ファイルを編集する際、毎回ファイルまでのパスを入力する方法と、一度ファイルまでのパスを登録して、手軽に読み出す方法があります。</li>'."\n"; 
	print '<li>パスとは、この編集システムから、対象ファイルまでのパスを指定する「相対パス」とトップディレクトリから指定する「絶対パス」があります。レンタルサーバの場合は、相対パスを指定された方が素早く対応が出来るかと思います。<br>'."\n"; 
	print '（例）../index.html  <br>(解説) ../ は１つ上のディレクトリを指定します。 ../../ファイル名 と２つ使用すると、２つ上のディレクトリを指定します。 </li>'."\n"; 
	print '<li>対応している日本語コードは、シフトJIS、JIS、EUCコードのみになります。Windowsで作成した場合は、シフトJISが大半です。</li>'."\n"; 
	print '<li>改行コードは基本的にはLF(\n)を選択して下さい。WindowsサーバはCR+LFになります。</li>'."\n"; 
	print '</ul>'."\n"; 
	print '<h2 class="subtitle">免責事項</h2>'."\n"; 
	print '<ul>'."\n"; 
	print '<li>このシステムを使用して如何なる損害が発生しても、制作者であるせっかくネットは一切の責任を取りません。</li>'."\n"; 
	print '<li>サーバにアップしているファイルは、必ずバックアップを取って下さい。</li>'."\n"; 
	print '<li>お問い合わせ、不都合のご一報は、せっかくネット「<A href="http://research.sekkaku.net/">CGI-research</A>」へお願いします。</li>'."\n"; 
	print '</ul>'."\n"; 
	print '<p align="right">&copy;<a href="http://www.sekkaku.net/">SEKKAKU-NET</a></p>'."\n"; 
	print '<p>&nbsp;</p>'."\n"; 
	print '</blockquote>'."\n";

	print '</body>'."\n"; 
	print '</html>'."\n"; 

	exit;

}


#------------------------------------------------------------------------------
#ファイルの読み込み
sub loadfile {

	my($file_dat) = @_;

	open(IN,"$file_dat");
	flock(IN, LOCK_EX);
	@LOG = <IN>;
	close(IN);

	return @LOG ;

}

#------------------------------------------------------------------------------
#ファイルの保存
sub savefile {

	my($file_dat, @LINES) = @_ ;

	open (OUT,">$file_dat") || &top("ファイルの書き換えが出来ません。\\n指定されたディレクトリは編集の権利が与えられていません。");
	flock(OUT, LOCK_EX);
	print OUT (@LINES);
	close (OUT);
	chmod(0666,"$file_dat");

}

#------------------------------------------------------------------------------
#ファイルの追加保存
sub savetofile {

	my($file_dat, @LINES) = @_ ;

	open (OUT,">>$file_dat") || &top("skediterの設置方法に誤りがあります。\\n設定ファイルの書き換えが出来ません。");
	flock(OUT, LOCK_EX);
	print OUT (@LINES);
	close (OUT);
	chmod(0666,"$file_dat");

}

#------------------------------------------------------------------------------
sub editlist{

	if(!$filepass){ &top("ファイルの指定がありませんでした。"); }
	
	if($FORM{'run'} eq "2"){
		foreach $tmplist (@editlist) {
			if($tmplist eq $filepass){ &top("指定されたファイル「$filepass」は\\nリストに登録済みです。"); }
		}
		&savetofile($editlist,$filepass."\n");
		@editlist = &loadfile($editlist);
		&top("指定されたファイル「$filepass」は\\nリストに追加されました。");
	}
	
	if($FORM{'run'} eq "3"){
		my @NEW = ();
		foreach $tmplist (@editlist) {
			$tmplist =~ s/\n$//;
			if($tmplist ne $filepass){ 
				push (@NEW,$tmplist."\n");
			}
		}
		&savefile($editlist,@NEW);
		@editlist = &loadfile($editlist);
		&top("指定されたファイル「$filepass」は\\nリストから削除されました。");
	}

}

#------------------------------------------------------------------------------
sub makefile{

	if(!$filepass){ &top("ファイルの指定がありませんでした。"); }
	&savefile($filepass,"");

	&top("指定された「$filepass」\\nファイルを作成しました。");

}

#------------------------------------------------------------------------------
sub dellfile{

	if(!-f $filepass){&top("指定されたファイルがありませんでした。");}
	unlink($filepass);
	&top("指定された「$filepass」\\nファイルを削除しました。");

}

#------------------------------------------------------------------------------
sub openset{

	if(!-f $filepass){ undef $FORM{'run'}; &top("指定されたファイルがありませんでした。");}
	my @FILES = &loadfile($filepass);
	$selectbr{'lf'} = " selected";
	
	foreach $tmplist (@FILES) {
		if($tmplist =~ /\r\n/){
			$selectbr{crlf} = " selected";
		}elsif($tmplist =~ /\r/){
			$selectbr{cr} = " selected";
		}
		$editfiletxt .= $tmplist;
	}
	
	if($FORM{'code'} eq "shift-jis"){
		from_to ( $editfiletxt , 'cp932' , 'utf8' ); 
		$selectcd{'sjis'} = " selected";
	}
	elsif($FORM{'code'} eq "euc"){
		from_to ( $editfiletxt , 'ceuc-jp' , 'utf8' ); 
		$selectcd{'euc'} = " selected";
	}
	elsif($FORM{'code'} eq "jis"){
		from_to ( $editfiletxt , '7bit-jis' , 'utf8' ); 
		$selectcd{'jis'} = " selected";
	}
	else{
		$selectcd{'utf8'} = " selected";
	}
	
	$openfile = $filepass;
	
	&top;
	
}


#------------------------------------------------------------------------------
sub saveset{

	if(!-f $FORM{'file'}){&top("指定されたファイルがありませんでした。");}

	my $editfiletxt = $FORM{'mes'};

	if($FORM{'code'} eq "shift-jis"){
		from_to ( $editfiletxt , 'utf8' , 'sjis' ); 
	}
	elsif($FORM{'code'} eq "euc"){
		from_to ( $editfiletxt , 'utf8' , 'ceuc-jp' ); 
	}
	elsif($FORM{'code'} eq "jis"){
		from_to ( $editfiletxt , 'utf8' , '7bit-jis' ); 
	}

	if($FORM{'br'} eq "LF"){
		$editfiletxt =~ s/\r\n/\n/g;
		$editfiletxt =~ s/\r/\n/g;
	}elsif($FORM{'br'} eq "CR"){
		$editfiletxt =~ s/\r\n/\r/g;
		$editfiletxt =~ s/\n/\r/g;
	}elsif($FORM{'br'} eq "CR+LF"){
		$editfiletxt =~ s/\r\n/\n/g;
		$editfiletxt =~ s/\r/\n/g;
		$editfiletxt =~ s/\n/\r\n/g;
	}

	&savefile($FORM{'file'},$editfiletxt);
	
	&top("指定された「$FORM{'file'}」\\nファイルの更新が完了しました。");
	
}

#------------------------------------------------------------------------------




